commit a4090428f83fbf9f3f53559bdb8c2b4f48652b9a
Author: Pavel Fidranský <fidransky@outlook.com>
Date:   Sat Oct 27 08:47:10 2018 +0200

    reworked Vertex, Group and Edge to ES6 classes; Vertex and Group extend newly created Node class

diff --git a/sources/src/main/webapp/js/components/edge.js b/sources/src/main/webapp/js/components/edge.js
index 4f8fc2a..2cd20d9 100644
--- a/sources/src/main/webapp/js/components/edge.js
+++ b/sources/src/main/webapp/js/components/edge.js
@@ -1,325 +1,307 @@
 /**
  * Class representing an edge of a graph in viewport.
- * @constructor
- * @param {object} props Properties of the edge.
  */
-function Edge(props) {
-	/** @prop {integer} id Unique identifier of the edge. */
-	this.id = props.id;
+class Edge {
+	/**
+	 * @constructor
+	 * @param {object} props Properties of the edge.
+	 */
+	constructor(props) {
+		/** @prop {integer} id Unique identifier of the edge. */
+		this.id = props.id;
+		/** @prop {array} subedgeInfo */
+		this.subedgeInfo = props.subedgeInfo;
 
-	var rootElement;
+		this._isHidden = false;
+		this._isDimmed = false;
+		this._isHighlighted = false;
+		this._isHighlightedAsRequired = false;
+		this._isHighlightedAsProvided = false;
 
-	var hidden = false;
-	var dimmed = false;
-	var highlighted = false;
-	var highlightedRequired = false;
-	var highlightedProvided = false;
+		this._fromNode = null;
+		this._toNode = null;
 
-	var fromNode = null;
-	var toNode = null;
+		this._start = null;
+		this._end = null;
+	}
 
-	var start = new Coordinates(0, 0);
-	var end = new Coordinates(0, 0);
-	
 	/**
 	 * Sets origin vertex of the edge without moving the starting point.
 	 * @param {Vertex} node Vertex that this edge is going from.
 	 */
-	this.setFrom = function(node) {
+	set from(node) {
 		if (!(node instanceof Vertex)) {
-			throw new TypeError(node.toString() + 'is not instance of Vertex');
+			throw new TypeError(node.toString() + ' is not an instance of Vertex');
 		}
 
-		fromNode = node;
+		this._fromNode = node;
+		this._start = node.center;
+	}
 
-		setStart(node.getCenter());
-	};
-	
 	/**
-	 * Returns origin vertex of the edge.
+	 * @returns {Vertex} origin vertex of the edge.
 	 */
-	this.getFrom = function() {
-		return fromNode;
-	};
+	get from() {
+		return this._fromNode;
+	}
 	
 	/**
 	 * Sets target vertex of the edge without moving the ending point.
 	 * @param {Vertex} node Vertex that this edge is going to.
 	 */
-	this.setTo = function(node) {
+	set to(node) {
 		if (!(node instanceof Vertex)) {
-			throw new TypeError(node.toString() + 'is not instance of Vertex');
+			throw new TypeError(node.toString() + ' is not an instance of Vertex');
 		}
 
-		toNode = node;
-
-		setEnd(node.getCenter());
-	};
+		this._toNode = node;
+		this._end = node.center;
+	}
 	
 	/**
-	 * Returns target vertex of the edge.
+	 * @returns {Vertex} target vertex of the edge
 	 */
-	this.getTo = function() {
-		return toNode;
-	};
+	get to() {
+		return this._toNode;
+	}
 	
 	/**
 	 * Moves starting point of the edge to new coordinates and rotates the lollipop.
 	 * @param {Coordinates} coords New starting coordinates of the edge.
 	 */
-	this.moveStart = function(coords) {
-		setStart(coords);
-		
-		var lines = rootElement.querySelectorAll('.line');
-		lines.forEach(function(line) {
-			line.setAttribute('x1', start.x);
-			line.setAttribute('y1', start.y);
+	set start(coords) {
+		if (!(coords instanceof Coordinates)) {
+			throw new TypeError(coords.toString() + ' is not an instance of Coordinates');
+		}
+
+		this._start = coords;
+
+		this._lineElements.forEach(line => {
+			line.setAttribute('x1', this._start.x);
+			line.setAttribute('y1', this._start.y);
 		});
-		
-		// arrow position and rotation
-		var position = getArrowPosition.call(this);
-		var rotation = getArrowRotation.call(this);
 
-		var arrow = rootElement.querySelector('.arrow');
-		arrow.setAttribute('transform', `rotate(${rotation}, ${position.x},${position.y}) translate(${position.x},${position.y})`);
-	};
-	
+		// icon position and rotation
+		let position = this._iconPosition;
+		let rotation = this._iconRotation;
+
+		this._iconElement.setAttribute('transform', `rotate(${rotation}, ${position.x},${position.y}) translate(${position.x},${position.y})`);
+	}
+
 	/**
 	 * Moved ending point of the edge to new coordinates and rotates the arrow.
 	 * @param {Coordinates} coords New ending coordinates of the edge.
 	 */
-	this.moveEnd = function(coords) {
-		setEnd(coords);
-		
-		var lines = rootElement.querySelectorAll('.line');
-		lines.forEach(function(line) {
-			line.setAttribute('x2', end.x);
-			line.setAttribute('y2', end.y);
+	set end(coords) {
+		if (!(coords instanceof Coordinates)) {
+			throw new TypeError(coords.toString() + ' is not an instance of Coordinates');
+		}
+
+		this._end = coords;
+
+		this._lineElements.forEach(line => {
+			line.setAttribute('x2', this._end.x);
+			line.setAttribute('y2', this._end.y);
 		});
 		
-		// arrow position and rotation
-		var position = getArrowPosition.call(this);
-		var rotation = getArrowRotation.call(this);
+		// icon position and rotation
+		let position = this._iconPosition;
+		let rotation = this._iconRotation;
 
-		var arrow = rootElement.querySelector('.arrow');
-		arrow.setAttribute('transform', `rotate(${rotation}, ${position.x},${position.y}) translate(${position.x},${position.y})`);
-	};
+		this._iconElement.setAttribute('transform', `rotate(${rotation}, ${position.x},${position.y}) translate(${position.x},${position.y})`);
+	}
 
 	/**
 	 * Toggles visibility of the edge.
 	 * @param {boolean} newValue True to hide the edge, false to display it.
 	 */
-	this.setHidden = function(newValue) {
-		hidden = newValue;
+	set isHidden(newValue) {
+		this._isHidden = newValue;
 
 		if (newValue) {
-			rootElement.classList.add('hidden');
+			this._rootElement.classList.add('hidden');
 		} else {
-			rootElement.classList.remove('hidden');
+			this._rootElement.classList.remove('hidden');
 		}
-	};
+	}
 
 	/**
 	 * Toggles transparency of the edge.
 	 * @param {boolean} newValue True to set the edge semitransparent, false to display it normally.
 	 */
-	this.setDimmed = function(newValue) {
-		dimmed = newValue;
+	set isDimmed(newValue) {
+		this._isDimmed = newValue;
 
 		if (newValue) {
-			rootElement.classList.add('edge--dimmed');
+			this._rootElement.classList.add('edge--dimmed');
 		} else {
-			rootElement.classList.remove('edge--dimmed');
+			this._rootElement.classList.remove('edge--dimmed');
 		}
-	};
+	}
 
-    /**
-     * @returns true if the edge is currently highlighted (in any way), otherwise false
-     */
-	this.isHighlighted = function () {
-		return highlighted;
-    };
+	/**
+	 * @returns true if the edge is currently highlighted (in any way), otherwise false
+	 */
+	get isHighlighted() {
+		return this._isHighlighted;
+	}
 
 	/**
 	 * Toggles highlighting of the edge.
 	 * @param {boolean} newValue True to highlight the edge, false to unhighlight.
 	 */
-	this.setHighlighted = function(newValue) {
-		highlighted = newValue;
+	set isHighlighted(newValue) {
+		this._isHighlighted = newValue;
 
 		if (newValue) {
-			rootElement.classList.add('edge--highlighted');
+			this._rootElement.classList.add('edge--highlighted');
 		} else {
-			rootElement.classList.remove('edge--highlighted');
+			this._rootElement.classList.remove('edge--highlighted');
 		}
-	};
+	}
 	
 	/**
 	 * Toggles highlighting of the edge between vertex and its requirement.
 	 * @param {boolean} newValue True to highlight the edge as required, false to unhighlight.
 	 */
-	this.setHighlightedRequired = function(newValue) {
-		highlightedRequired = newValue;
+	set isHighlightedAsRequired(newValue) {
+		this._isHighlightedAsRequired = newValue;
 
 		if (newValue) {
-			rootElement.classList.add('edge--highlighted-required');
-			rootElement.classList.remove('edge--highlighted-provided');
+			this._rootElement.classList.add('edge--highlighted-as-required');
+			this._rootElement.classList.remove('edge--highlighted-as-provided');
 
 		} else {
-			rootElement.classList.remove('edge--highlighted-required');
+			this._rootElement.classList.remove('edge--highlighted-as-required');
 		}
-	};
+	}
 	
 	/**
 	 * Toggles highlighting of the edge between vertex and its dependent.
 	 * @param {boolean} newValue True to highlight the edge as provided, false to unhighlight.
 	 */
-	this.setHighlightedProvided = function(newValue) {
-		highlightedProvided = newValue;
+	set isHighlightedAsProvided(newValue) {
+		this._isHighlightedAsProvided = newValue;
 
 		if (newValue) {
-			rootElement.classList.remove('edge--highlighted-required');
-			rootElement.classList.add('edge--highlighted-provided');
+			this._rootElement.classList.remove('edge--highlighted-as-required');
+			this._rootElement.classList.add('edge--highlighted-as-provided');
 
 		} else {
-			rootElement.classList.remove('edge--highlighted-provided');
+			this._rootElement.classList.remove('edge--highlighted-as-provided');
 		}
-	};
-	
+	}
+
 	/**
 	 * Creates a new DOM element representing the edge in memory. Binds user interactions to local handler functions.
 	 * @returns {Element} SVG DOM element.
 	 */
-	this.render = function() {
-		rootElement = DOM.createSvgElement('g', {
-			'class': 'edge',
-			'data-id': props.id,
-			'data-from': props.from,
-			'data-to': props.to,
-		});
+	render() {
+		// icon
+		let position = this._iconPosition;
+		let rotation = this._iconRotation;
 
-		rootElement.appendChild(DOM.createSvgElement('line', {
-			'class': 'line',
-			'x1': start.x,
-			'y1': start.y,
-			'x2': end.x,
-			'y2': end.y,
-			'stroke': 'white',
-			'stroke-width': 5,
-		}));
-		
-		rootElement.appendChild(DOM.createSvgElement('line', {
-			'class': 'line',
-			'x1': start.x,
-			'y1': start.y,
-			'x2': end.x,
-			'y2': end.y,
-		}));
-
-		// arrow position and rotation
-		var position = getArrowPosition.call(this);
-		var rotation = getArrowRotation.call(this);
-		
-		// arrow
-		var arrow = DOM.createSvgElement('g', {
-			'class': 'arrow',
-			'data-edgeId': this.id,
-			'transform': `rotate(${rotation}, ${position.x},${position.y}) translate(${position.x},${position.y})`,
-		});
-		arrow.appendChild(DOM.createSvgElement('polygon', {
-			'points': '0,-10 30,0 0,10',
+		this._iconElement = DOM.s('g', {
+			class: 'arrow',
+			transform: `rotate(${rotation}, ${position.x},${position.y}) translate(${position.x},${position.y})`,
+			onClick: this._onEdgeClick.bind(this),
+		}, [
+			DOM.s('polygon', {
+				points: '0,-10 30,0 0,10',
+			}),
+		]);
+
+		// lines
+		this._lineElements = [
+			DOM.s('line', {
+				class: 'line',
+				x1: this._start.x,
+				y1: this._start.y,
+				x2: this._end.x,
+				y2: this._end.y,
+				stroke: 'white',
+				'stroke-width': 5,
+			}),
+			DOM.s('line', {
+				class: 'line',
+				x1: this._start.x,
+				y1: this._start.y,
+				x2: this._end.x,
+				y2: this._end.y,
+			}),
+		];
 
-		}));
-		arrow.addEventListener('click', click.bind(this));
-		rootElement.appendChild(arrow);
+		// root
+		this._rootElement = DOM.s('g', {
+			class: 'edge',
+			'data-id': this.id,
+			'data-from': this.from.name,
+			'data-to': this.to.name,
+		}, [].concat(this._lineElements, this._iconElement));
 
-		return rootElement;
-	};
+		return this._rootElement;
+	}
 	
 	/**
 	 * Removes the DOM element representing the edge from document.
 	 */
-	this.remove = function() {
-		rootElement.remove();
-	};
+	remove() {
+		this._rootElement.remove();
+	}
 
 	/**
 	 * Exports the edge to a new, plain JS object.
 	 * @returns {Object} exported edge
 	 */
-	this.export = function() {
+	export() {
 		return {
-			subedgeInfo: props.subedgeInfo,
-			from: this.getFrom().id,
-			to: this.getTo().id,
+			subedgeInfo: this.subedgeInfo,
+			from: this.from.id,
+			to: this.to.id,
 			text: '',
 			id: this.id,
 		};
-	};
+	}
 
 	/**
 	 * Edge click interaction. Highlights the edge and vertices related to it. Reveals edge popover.
 	 * @param {Event} e Click event.
 	 */
-	function click(e) {
-		app.viewportComponent.edgePopoverComponent.body = props.subedgeInfo;
+	_onEdgeClick(e) {
+		app.viewportComponent.edgePopoverComponent.body = this.subedgeInfo;
 		app.viewportComponent.edgePopoverComponent.position = new Coordinates(e.clientX, e.clientY);
 		app.viewportComponent.edgePopoverComponent.open();
 
 		// unhighlight other edges
-		app.edgeList.filter(function(edge) {
+		app.edgeList.filter(edge => {
 			return edge !== this;
-		}, this).forEach(function(edge) {
-			edge.setHighlighted(false);
-			edge.getFrom().setHighlighted(false);
-			edge.getTo().setHighlighted(false);
+		}).forEach(edge => {
+			edge.from.isHighlighted = false;
+			edge.to.isHighlighted = false;
+			edge.isHighlighted = false;
 		});
 
 		// highlight this edge
-		this.setHighlighted(!highlighted);
-		this.getFrom().setHighlighted(highlighted);
-		this.getTo().setHighlighted(highlighted);
+		this.from.isHighlighted = !this.isHighlighted;
+		this.to.isHighlighted = !this.isHighlighted;
+		this.isHighlighted = !this.isHighlighted;
 	}
-	
-	/**
-	 * Sets new coordinates of the starting point of the edge.
-	 * @param {Coordinates} coords New starting coordinates of the edge.
-	 */
-	function setStart(coords) {
-		if (!(coords instanceof Coordinates)) {
-			throw new TypeError(coords.toString() + 'is not instance of Coordinates');
-		}
 
-		start = coords;
-	}
-	
 	/**
-	 * Sets new coordinates of the ending point of the edge.
-	 * @param {Coordinates} coords New ending coordinates of the edge.
+	 * @returns {Coordinates} Current position of the icon.
 	 */
-	function setEnd(coords) {
-		if (!(coords instanceof Coordinates)) {
-			throw new TypeError(coords.toString() + 'is not instance of Coordinates');
-		}
-
-		end = coords;
-	}
-	
-	/**
-	 * @returns {Coordinates} Current position of the arrow.
-	 */
-	function getArrowPosition() {
-		// arrow is placed at 2/3 of the distance from start to end
+	get _iconPosition() {
+		// icon is placed at 2/3 of the distance from start to end
 		return new Coordinates(
-			(start.x + 2 * end.x) / 3,
-			(start.y + 2 * end.y) / 3,
+			(this._start.x + 2 * this._end.x) / 3,
+			(this._start.y + 2 * this._end.y) / 3,
 		);
 	}
-	
+
 	/**
-	 * @returns {float} Current rotation of the arrow in degrees.
+	 * @returns {float} Current rotation of the icon in degrees.
 	 */
-	function getArrowRotation() {
-		return -1 * Math.atan2(end.x - start.x, end.y - start.y) * 180 / Math.PI + 90;
+	get _iconRotation() {
+		return -1 * Math.atan2(this._end.x - this._start.x, this._end.y - this._start.y) * 180 / Math.PI + 90;
 	}
 }
diff --git a/sources/src/main/webapp/js/components/floatingPoint.js b/sources/src/main/webapp/js/components/floatingPoint.js
index c426af3..0495594 100644
--- a/sources/src/main/webapp/js/components/floatingPoint.js
+++ b/sources/src/main/webapp/js/components/floatingPoint.js
@@ -39,7 +39,7 @@ function FloatingPoint() {
 			throw new TypeError(edge.toString() + 'is not instance of Edge');
 		}
 
-		edge.moveEnd(this.getPosition());
+		edge.end = this.getPosition();
 		
 		inEdgeList.push(edge);
 	};
@@ -53,7 +53,7 @@ function FloatingPoint() {
 			throw new TypeError(edge.toString() + 'is not instance of Edge');
 		}
 
-		edge.moveStart(this.getPosition());
+		edge.start = this.getPosition();
 		
 		outEdgeList.push(edge);
 	};
@@ -97,29 +97,29 @@ function FloatingPoint() {
 			var edgeOffsetY = 0;
 		}
 
-		var archetypeList = Object.keys(node.getRelatedArchetypeMap()).map(function(archetypeIndex) {
+		var archetypeList = Object.keys(node.relatedArchetypeMap).map(function(archetypeIndex) {
 			return parseInt(archetypeIndex);
 		});
 		var archetypeIconOrder;
 
 		// redraw dependent edges
 		inEdgeList.forEach(function(edge) {
-			archetypeIconOrder = archetypeList.indexOf(edge.getFrom().archetype);
+			archetypeIconOrder = archetypeList.indexOf(edge.from.archetype);
 
-			edge.moveEnd(new Coordinates(
+			edge.end = new Coordinates(
 				position.x / app.zoom.scale,
 				(position.y + edgeOffsetY + archetypeIconOrder * 20) / app.zoom.scale,
-			));
 		}, this);
+			);
 
 		outEdgeList.forEach(function(edge) {
-			archetypeIconOrder = archetypeList.indexOf(edge.getTo().archetype);
+			archetypeIconOrder = archetypeList.indexOf(edge.to.archetype);
 
-			edge.moveStart(new Coordinates(
+			edge.start = new Coordinates(
 				position.x / app.zoom.scale,
 				(position.y + edgeOffsetY + archetypeIconOrder * 20) / app.zoom.scale,
-			));
 		}, this);
+			);
 	};
 
 	/**
@@ -152,7 +152,7 @@ function FloatingPoint() {
 	 * @param {boolean} newValue True to highlight the node as required, otherwise false.
 	 */
 	this.setHighlightedRequired = function(newValue) {
-		node.setHighlightedRequired(newValue);
+		node.isHighlightedAsRequired = newValue;
 	};
 
 	/**
@@ -160,6 +160,6 @@ function FloatingPoint() {
 	 * @param {boolean} newValue True to highlight the node as provided, otherwise false.
 	 */
 	this.setHighlightedProvided = function(newValue) {
-		node.setHighlightedProvided(newValue);
+		node.isHighlightedAsProvided = newValue;
 	};
 }
diff --git a/sources/src/main/webapp/js/components/group.js b/sources/src/main/webapp/js/components/group.js
index b515143..e9e1e1d 100644
--- a/sources/src/main/webapp/js/components/group.js
+++ b/sources/src/main/webapp/js/components/group.js
@@ -1,369 +1,174 @@
 /**
  * Class representing a group of vertices in graph. A group is composed from one or more vertices.
- * @constructor
- * @param {object} props Properties of the group.
  */
-function Group(props) {
-	/** @prop {integer} id Unique identifier of the group. */
-	this.id = props.hasOwnProperty('id') ? props.id : app.groupList.length + 1;
-	/** @prop {string} name Name of the group. */
-	this.name = props.hasOwnProperty('name') ? props.name : 'Group ' + this.id;
-	/** @prop {array} symbol Symbol of the group. */
-	this.symbol = app.markSymbol.getMarkSymbol();
-
-	var rootElement;
-	var vertexListComponent;
-
-	var position = new Coordinates(0, 0);
-	var size = {
-		width: 70,
-		height: 70,
-	};
-	var floater = null;
-
-	var pan = false;
-	var excluded = false;
-    var iconsDisplayed = false;
-
-	var highlighted = false;
-	var highlightedRequiredNeighbours = false;
-	var highlightedProvidedNeighbours = false;
-	var highlightedArchetypeNeighbours = false;
-	var found = false;
-	var dimmed = false;
-
-	var vertexList = [];
-	var relatedArchetypeMap = {};
+class Group extends Node {
+	/**
+	 * @constructor
+	 * @param {object} props Properties of the group.
+	 */
+	constructor(props) {
+		super(props);
+
+		this._size = new Dimensions(70, 70);
+
+		this._vertexList = [];
+	}
+
+	/**
+	 * @returns {Group} newly created group
+	 */
+	static create() {
+		return new Group({
+			id: app.groupList.length + 1,
+			name: 'Group ' + (app.groupList.length + 1),
+		});
+	}
 
 	/**
 	 * Adds a new vertex to the group. The vertex is set as excluded and its DOM element is removed from document. Its edges are moved so that they end at the group.
 	 * @param {Vertex} vertex Vertex to be added to the group.
 	 */
-	this.addVertex = function(vertex) {
+	addVertex(vertex) {
 		if (!(vertex instanceof Vertex)) {
-			throw new TypeError(vertex.toString() + 'is not instance of Vertex');
+			throw new TypeError(vertex.toString() + ' is not an instance of Vertex');
 		}
 
-		if (vertexList.length === 0) {
-			position = vertex.getPosition();
+		if (this._vertexList.length === 0) {
+			this.position = vertex.position;
 		}
 
-		var isIconShown = this.isIconsDisplayed();
-		if(isIconShown) showIconClick.bind(this)(null);
-
-		vertex.removeIcon();
-		vertex.setGroup(this);
-		vertex.setExcluded(this.isExcluded());
-		vertex.remove(this.isExcluded());	// edges of the vertex should be removed from DOM only if group is excluded
+		vertex.group = this;
+		vertex.isExcluded = this.isExcluded;
+		vertex.remove(this.isExcluded);	// edges of the vertex should be removed from DOM only if group is excluded
 
-		vertex.getInEdgeList().forEach(function(edge) {
-			if (this.isExcluded()) {
+		let inEdgeList = vertex.inEdgeList;
+		inEdgeList.forEach(edge => {
+			if (this.isExcluded) {
 				floater.addInEdge(edge);
 			} else {
-				edge.moveEnd(this.getCenter());
+				edge.end = this.center;
 			}
-		}, this);
+		});
 
-		vertex.getOutEdgeList().forEach(function(edge) {
-			if (this.isExcluded()) {
+		let outEdgeList = vertex.outEdgeList;
+		outEdgeList.forEach(edge => {
+			if (this.isExcluded) {
 				floater.addOutEdge(edge);
 			} else {
-				edge.moveStart(this.getCenter());
+				edge.start = this.center;
 			}
-		}, this);
+		});
 
-		var vertexRelatedArchetypeMap = vertex.getRelatedArchetypeMap();
-		for (var archetypeIndex in vertexRelatedArchetypeMap) {
-			if (!relatedArchetypeMap.hasOwnProperty(archetypeIndex)) {
-				relatedArchetypeMap[archetypeIndex] = 0;
+		let vertexRelatedArchetypeMap = vertex.relatedArchetypeMap;
+		for (let archetypeIndex in vertexRelatedArchetypeMap) {
+			if (this.relatedArchetypeMap.hasOwnProperty(archetypeIndex) === false) {
+				this.relatedArchetypeMap[archetypeIndex] = 0;
 			}
-	
-			relatedArchetypeMap[archetypeIndex] += vertexRelatedArchetypeMap[archetypeIndex];
+
+			this.relatedArchetypeMap[archetypeIndex] += vertexRelatedArchetypeMap[archetypeIndex];
 		}
 
-		app.viewportComponent.removeVertex(vertex);
+		app.viewportComponent.removeNode(vertex);
 
-		if (vertexListComponent) {
-			vertexListComponent.appendChild(vertex);
+		if (this._vertexListComponent) {
+			this._vertexListComponent.appendChild(vertex);
 		}
 
-		vertexList.push(vertex);
-        if(isIconShown) showIconClick.bind(this)(null);
-	};
+		this._vertexList.push(vertex);
+	}
 
 	/**
 	 * Removes a vertex from the group. The vertex is returned back to the viewport and its edges are moved to it.
 	 * @param {Vertex} vertex Vertex to be removed from the group.
 	 */
-	this.removeVertex = function(vertex) {
+	removeVertex(vertex) {
 		if (!(vertex instanceof Vertex)) {
-			throw new TypeError(vertex.toString() + 'is not instance of Vertex');
+			throw new TypeError(vertex.toString() + ' is not an instance of Vertex');
 		}
 
-		vertex.setGroup(null);
+		vertex.group = null;
 
-		vertex.getInEdgeList().forEach(function(edge) {
-			edge.moveEnd(this.getCenter());
-		}, vertex);
+		let inEdgeList = vertex.inEdgeList;
+		inEdgeList.forEach(edge => {
+			edge.end = vertex.center;
+		});
 
-		vertex.getOutEdgeList().forEach(function(edge) {
-			edge.moveStart(this.getCenter());
-		}, vertex);
+		let outEdgeList = vertex.outEdgeList;
+		outEdgeList.forEach(edge => {
+			edge.start = vertex.center;
+		});
 
-		var vertexRelatedArchetypeMap = vertex.getRelatedArchetypeMap();
-		for (var archetypeIndex in vertexRelatedArchetypeMap) {
-			relatedArchetypeMap[archetypeIndex] -= vertexRelatedArchetypeMap[archetypeIndex];
+		let vertexRelatedArchetypeMap = vertex.relatedArchetypeMap;
+		for (let archetypeIndex in vertexRelatedArchetypeMap) {
+			this.relatedArchetypeMap[archetypeIndex] -= vertexRelatedArchetypeMap[archetypeIndex];
 		}
 
-		app.viewportComponent.addVertex(vertex);
+		app.viewportComponent.addNode(vertex);
 
-		if (vertexListComponent) {
-			vertexListComponent.removeChild(vertex);
+		if (this._vertexListComponent) {
+			this._vertexListComponent.removeChild(vertex);
 		}
 
-		vertexList.splice(vertexList.indexOf(vertex), 1);
-	};
-	
+		this._vertexList.splice(this._vertexList.indexOf(vertex), 1);
+	}
+
 	/**
-	 * @returns {array<Vertex>} List of vertices added to the group.
+	 * @returns {array<Vertex>} List of vertices added to this group.
 	 */
-	this.getVertexList = function() {
-		return vertexList;
-	};
+	get vertexList() {
+		return this._vertexList;
+	}
+
+	/**
+	 * @returns {integer} Number of vertices added to this group.
+	 */
+	countVertices() {
+		return this._vertexList.length;
+	}
 
 	/**
 	 * @returns {array<Edge>} List of edges going to vertices added to the group.
 	 */
-	this.getInEdgeList = function() {
-		var edgeList = [];
+	get inEdgeList() {
+		let edgeList = [];
 
-		vertexList.forEach(function(vertex) {
-			vertex.getInEdgeList().filter(function(edge) {
+		this._vertexList.forEach(vertex => {
+			let inEdgeList = vertex.inEdgeList;
+			inEdgeList.filter(edge => {
 				return edgeList.indexOf(edge) === -1;
-			}).forEach(function(edge) {
+			}).forEach(edge => {
 				edgeList.push(edge);
 			});
 		});
 
 		return edgeList;
-	};
+	}
 
 	/**
 	 * @returns {array<Edge>} List of edges going from vertices added to the group.
 	 */
-	this.getOutEdgeList = function() {
-		var edgeList = [];
+	get outEdgeList() {
+		let edgeList = [];
 
-		vertexList.forEach(function(vertex) {
-			vertex.getOutEdgeList().filter(function(edge) {
+		this._vertexList.forEach(vertex => {
+			let outEdgeList = vertex.outEdgeList;
+			outEdgeList.filter(edge => {
 				return edgeList.indexOf(edge) === -1;
-			}).forEach(function(edge) {
+			}).forEach(edge => {
 				edgeList.push(edge);
 			});
 		});
 
 		return edgeList;
-	};
-
-	/**
-	 * @returns {array<Edge>} List of all edges related to vertices added to the group.
-	 */
-	this.getEdgeList = function() {
-		// TODO: some edges get duplicated in the resulting array this way
-
-		return [].concat(this.getInEdgeList(), this.getOutEdgeList());
-	};
-
-	/**
-	 * @returns {object} Map with archetype indexes as keys and counters of their instances as values.
-	 */
-	this.getRelatedArchetypeMap = function() {
-		return relatedArchetypeMap;
-	};
-
-	/**
-	 * @returns {Coordinates} Current position of the group in graph.
-	 */
-	this.getPosition = function() {
-		return position;
-	};
-
-	/**
-	 * Updates the current position of the group in graph.
-	 */
-	this.setPosition = function(coords) {
-		if (!(coords instanceof Coordinates)) {
-			throw new TypeError(coords.toString() + 'is not instance of Coordinates');
-		}
-
-		position = coords;
-	};
-
-	/**
-	 * @returns {Coordinates} Centre of the group.
-	 */
-	this.getCenter = function() {
-		return new Coordinates(
-			position.x + size.width / 2,
-			position.y + size.height / 2,
-		);
-	};
-
-	/**
-	 * Moves the group to a new position in graph. Edges related to vertices in the group are moved as well.
-	 * @param {Coordinates} coords Coordinates to be moved to.
-	 */
-	this.move = function(coords) {
-		if (!(coords instanceof Coordinates)) {
-			throw new TypeError(coords.toString() + 'is not instance of Coordinates');
-		}
-
-		rootElement.setAttribute('x', coords.x);
-		rootElement.setAttribute('y', coords.y);
-
-		vertexList.forEach(function(vertex) {
-			vertex.getInEdgeList().forEach(function(edge) {
-				edge.moveEnd(new Coordinates(
-					coords.x + size.width / 2,
-					coords.y + size.height / 2,
-				));
-			});
-
-			vertex.getOutEdgeList().forEach(function(edge) {
-				edge.moveStart(new Coordinates(
-					coords.x + size.width / 2,
-					coords.y + size.height / 2,
-				));
-			});
-		}, this);
-	};
-
-	/**
-	 * Sets the group as found. Highlighting is skipped when the group is excluded.
-	 * @param {boolean} newValue True to mark the group as found, otherwise false.
-	 */
-	this.setFound = function(newValue) {
-		found = newValue;
-
-		if (excluded) return;
-		
-		if (newValue) {
-			rootElement.classList.add('node--found');
-		} else {
-			rootElement.classList.remove('node--found');
-		}
-	};
-
-	/**
-	 * Toggles transparency of the group.
-	 * @param {boolean} newValue True to set the group semitransparent, false to display it normally.
-	 */
-	this.setDimmed = function(newValue) {
-		dimmed = newValue;
-
-		if (excluded) return;
-
-		if (newValue) {
-			rootElement.classList.add('node--dimmed');
-		} else {
-			rootElement.classList.remove('node--dimmed');
-		}
-	};
-
-    /**
-     * @returns {boolean} true if icon in all neighbours should be displayed, false otherwise
-     */
-    this.isIconsDisplayed = function () {
-        return iconsDisplayed;
-    };
-
-	/**
-	 * @returns true if the group is currently highlighted (in any way), otherwise false
-	 */
-	this.isHighlighted = function() {
-		return highlighted;
-	};
-
-	/**
-	 * Toggles highlighting of the group.
-	 * @param {boolean} newValue True to highlight the group, false to unhighlight.
-	 */
-	this.setHighlighted = function(newValue) {
-		highlighted = newValue;
-
-		if (newValue) {
-			rootElement.classList.add('node--highlighted');
-		} else {
-			rootElement.classList.remove('node--highlighted');
-		}
-	};
-
-	/**
-	 * Toggles inner state of the group marking whether highlighting of its requirements is active.
-	 * @param {boolean} newValue True to highlight the neighbours, false to unhighlight.
-	 */
-	this.setHighlightedRequiredNeighbours = function(newValue) {
-		highlightedRequiredNeighbours = newValue;
-	};
-
-	/**
-	 * Toggles inner state of the group marking whether highlighting of its dependents is active.
-	 * @param {boolean} newValue True to highlight the neighbours, false to unhighlight.
-	 */
-	this.setHighlightedProvidedNeighbours = function(newValue) {
-		highlightedProvidedNeighbours = newValue;
-	};
-
-	/**
-	 * Toggles inner state of the group marking whether highlighting of instances of a vertex archetype is active.
-	 * @param {boolean} newValue True to highlight the neighbours, false to unhighlight.
-	 */
-	this.setHighlightedArchetypeNeighbours = function(newValue) {
-		highlightedArchetypeNeighbours = newValue;
-	};
-
-	/**
-	 * Toggles highlighting of the group to mark it as requirement of some other node.
-	 * @param {boolean} newValue True to highlight, false to unhighlight.
-	 */
-	this.setHighlightedRequired = function(newValue) {
-		if (newValue) {
-			rootElement.classList.add('node--highlighted-required');
-		} else {
-			rootElement.classList.remove('node--highlighted-required');
-		}
-	};
-	
-	/**
-	 * Toggles highlighting of the group to mark it as dependent of some other node.
-	 * @param {boolean} newValue True to highlight, false to unhighlight.
-	 */
-	this.setHighlightedProvided = function(newValue) {
-		if (newValue) {
-			rootElement.classList.add('node--highlighted-provided');
-		} else {
-			rootElement.classList.remove('node--highlighted-provided');
-		}
-	};
-	
-	/**
-	 * Toggles highlighting of the group to mark it as instance of archetype related to some other node.
-	 * @param {boolean} newValue True to highlight, false to unhighlight.
-	 */
-	this.setHighlightedArchetype = function(newValue) {
-		if (newValue) {
-			rootElement.classList.add('node--highlighted-archetype');
-		} else {
-			rootElement.classList.remove('node--highlighted-archetype');
-		}
-	};
+	}
 
 	/**
-	 * @returns {boolean} True is the group is currently excluded from the viewport, otherwise false.
+	 * For some reason must be here to work.
+	 * @inheritdoc
 	 */
-	this.isExcluded = function() {
-		return excluded;
-	};
+	get isExcluded() {
+		return super.isExcluded;
+	}
 
 	/**
 	 * Toggles excluded state of the group. If the group is set excluded, a new floating point is created to connect it with 
